/**
 * 版权所有 ©2021 
 * 工程名：yearBooks
 * 文件名：NcjjZczDao.java
 * 创建日期：2021年10月21日 上午9:19:04
 * 作者：duanxiaomingzi
 */
package com.lion.dao;

import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

import com.lion.entity.XmySl;

import jodd.util.StringUtil;

/**
 * 类描述 饲料
 * @author duanxiaomingzi
 * @since 2021年10月21日
 */
@Repository
public class XmySlDao {
	@Resource
	private JdbcTemplate jdbc;
	public int add(XmySl z){
		String sql="insert into xmy_sl (orgid,year,zsl,nsl,jqsl,hj,createTime,createUser) values (?,?,?,?,?,?,?,?)";
		return jdbc.update(sql,z.getOrgid(),z.getYear(),z.getZsl(),z.getNsl(),z.getJqsl()
				,z.getHj(),z.getCreateTime(),z.getCreateUser());
	}
	public int update(XmySl z){
		String sql="update xmy_sl set year=?,zsl=?,nsl=?,jqsl=?,hj=?,updateTime=?,updateUser=? where id=?";
		return jdbc.update(sql,z.getYear(),z.getZsl(),z.getNsl(),z.getJqsl(),z.getHj(),z.getUpdateTime(),z.getUpdateUser()
				,z.getId());
	}
	public int delete(int id){
		String sql="delete from xmy_sl where id=?";
		return jdbc.update(sql,id);
	}
	/**
	 * 方法描述 校验当前年度该单位是否已经录入过数据
	 * @author duanxiaomingzi
	 * @since 2021年10月21日
	 * @param z
	 * @return	
	 */
	public int checkIfExistByYearAndOrg(XmySl z){
		String sql="select count(id) from xmy_sl where year=? and orgid=?";
		if(StringUtil.isNotEmpty(z.getId())){
			sql+=" and id<>"+z.getId();
		}
		return jdbc.queryForObject(sql,new Object[]{z.getYear(),z.getOrgid()}, Integer.class);
	}
	/**
	 * 方法描述 根据部门id查询数据
	 * @author duanxiaomingzi
	 * @since 2021年10月21日
	 * @param year 年度
	 * @param orgid 部门id
	 * @return	
	 */
	public List<Map<String,Object>> getList(String year,String orgid,int start,int limit){
		String sql="select z.*,o.name orgname from xmy_sl z left join orgdept o on z.orgid=o.id where orgid like ?";
		if(StringUtil.isNotEmpty(year)){
			sql+=" and year="+year;
		}
		sql+=" order by year desc limit ?,?";
		return jdbc.queryForList(sql,orgid+"%",start,limit);
	}
	/**
	 * 方法描述 获取数量
	 * @author duanxiaomingzi
	 * @since 2021年10月21日
	 * @param year 年度
	 * @param orgid 部门id
	 * @return	
	 */
	public int getListCount(String year,String orgid){
		String sql="select count(id) from xmy_sl where orgid like ?";
		if(StringUtil.isNotEmpty(year)){
			sql+=" and year="+year;
		}
		return jdbc.queryForObject(sql,new Object[]{orgid+"%"},Integer.class);
	}
}
